require 'Thread'
require 'Iterator'

class Message
  attr("number",true)
  attr("title",true)
  attr("writer",true)
  attr("mail",true)
  attr("date",true)
  attr("url",true)
  attr("content",true)
  attr("parent",true)
  attr("major",true)
  attr("minor",true)
  def hit?(keys,andor='and')
	flag = andor == 'and'
	$stdout.flush
	for key in keys
		reg = Regexp.new(key,nil,'s')
		$stdout.flush
		if andor=='and' then
			if @title =~ reg || @content =~ reg then
				next
			else
				flag = false
				break
			end
		else
			if @title =~ reg || @content =~ reg then
				flag = true
				break
			end
		end
	end
	return flag
  end
end

class MessageDB
	attr('messagesdic',true)
	attr('messages',true)
	attr('lastIndex',true)
	attr('loadThread',false)

	def MessageDB.purse(lines,i=nil)
		i.next while (i.get !~ %r|<table width=80% bgcolor=#FFFFFF border=1><tr><td>|) and not i.last?
		if i.last? then
		  return nil
		end

		mes = Message.new

		i.next(2)
		mes.number=$1.to_i if i.get =~ %r|NO\.(\d+)|
		i.next
		mes.title = $1 if 	i.get =~ %r|^(.*)</font>|

		i.next(2)
		line = i.get
		case line
		when %r|e/ <a href\=mailto\:([^>]+)>(.+)</a><br><|
			mes.writer = $2
			mes.mail = $1
		when %r|e/ (<.*>)?(.*)<br><|
			mes.writer = $2 if i.get =~ %r|e/ (<.*>)?(.*)<br><|
		end
		i.next
		i.get =~ %r|e/ (.*)<br>|
		mes.date = $1

		i.next
		i.get =~ %r|URL/ (.*)<br>"|
		mes.url = $1

		i.next(3)
		text = i.get.gsub("^<td><br>","")
		
		if i.get !~ %r|</td>$| then
			while i.get !~ %r|</td>$|
				text += i.get
				text.next
			end
		end

		text.gsub!("</td>$","")
#		text.gsub!("<br>","\n")
#		text.gsub!('<font color="#B6B6B6">',"")
#		text.gsub!('</font>',"")

		mes.content = text
		i.next
		if i.get =~ %r|</table></blockquote><div align=right>LNO\.(\d+)| then
		  mes.parent=$1.to_i
		end

		i.next until i.get =~ %r|</td></tr></table><br>|

		return mes
	end

	def load(filename,index1='',index2='')
			  	return unless test(?e,filename )
			 	lines = IO.readlines(filename)
				i = Iterator.new(lines)
				while not i.last?
					mes = MessageDB.purse(lines,i)
					if mes != nil then
						mes.major = index1
						mes.minor = index2
						@messagesdic[mes.number]=mes
						@messages << mes
					end
				end
			  	@lastIndex = filename # .gsub("\.\./","")
	end
	
	def initialize
		@messagesdic = {}
		@messages = []
		@lastIndex = 1
		@loadThread = Thread.fork{
		  	filename = "GPMWorldBBSAllLog.htm"
		  	if test(?e,filename) then
				print "'#{filename}' is exist.\n"
				$stdout.flush
				load(filename)
			else
				print "'#{filename}' is not exist.\n"
				for index1 in 1..100
				  for index2 in 0..9
				  	filename = sprintf("log%d-%d.html",index1,index2)
					load(filename,index1,index2)
				  end
				end
			end
			print "Log file loading finished.\n"
		}
	end
	
	def loading?
		@loadThread.alive?
	end
end


$messageDB = MessageDB.new
